/*!
    \file  main.c
    \brief running LED
    
    \version 2025-02-10, V2.4.0, demo for GD32E23x
*/

/*
    Copyright (c) 2025, GigaDevice Semiconductor Inc.

    Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, this 
       list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice, 
       this list of conditions and the following disclaimer in the documentation 
       and/or other materials provided with the distribution.
    3. Neither the name of the copyright holder nor the names of its contributors 
       may be used to endorse or promote products derived from this software without 
       specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT 
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
OF SUCH DAMAGE.
*/

#include "gd32e23x.h"
#include "systick.h"
#include "uart.h"
#include "uart_ring_buffer.h"
#include "board_config.h"
#include "gpio.h"
#include "bootloader.h"

/*!
    \brief      main function
    \param[in]  none
    \param[out] none
    \retval     none
*/
int main(void)
{
    uint8_t buf[1];

    uart_ring_buffer_init();

    if (rcu_flag_get(RCU_FLAG_SWRST) == RESET)
    {
        check_flash_and_jump((uint8_t*)FLASH_FLAG_ADDRESS);
    }

    systick_config();
    gpio_init();
    rs485_init();

    // gpio_bit_write(MOTOR_EN_PORT, MOTOR_EN_PIN, RESET);

    delay_ms(100);
    rs485_send_str((uint8_t*)"ok", 2);
    delay_ms(100);
    // wait rs485 send complete: DE high -> low

    while (uart_ring_buffer_get() != 0x30);
    rs485_send_str((uint8_t*)"ok", 2);

    while (uart_ring_buffer_get() != 0x31);
    rs485_send_str((uint8_t*)"ok", 2);

    ymodem_receive(buf);

    delay_ms(100);

    check_flash_and_jump((uint8_t*)FLASH_FLAG_ADDRESS);

    while(1){
   
    }
}
